#include <bits/stdc++.h>
using namespace std;

int main() {
  int n, m;
  cin >> n >> m;
  vector<vector<int> > cap(n, vector<int>(n));
  for (int i = 0; i < m; i++) {
    int u, v, c;
    cin >> u >> v >> c;
    cap[u][v] = c;
  }
  vector<vector<int> > flow(n, vector<int>(n));
  int s = 0;
  int t = n - 1;

  int total = 0;
  for(;;) {
  
    queue<int> q;
    vector<int> from(n, -1);
    q.push(s);
    from[s] = -2;
    while (!q.empty()) {
      int u = q.front();
      q.pop();
      for (int i = 0; i < n; i++) {
        if (from[i] == -1 && cap[u][i] - flow[u][i] > 0) {
          from[i] = u;
          q.push(i);
        }
      }
    }
    if (from[t] < 0) break;

    int u = t;
    int delta = cap[from[u]][u] - flow[from[u]][u];
    while (from[u] >= 0) {
      delta = min(delta, cap[from[u]][u] - flow[from[u]][u]);
      u = from[u];
    }
    assert(delta > 0);
    total += delta;
    u = t;
    while (from[u] >= 0) {
      flow[from[u]][u] += delta;
      flow[u][from[u]] -= delta;
      u = from[u];
    }
  }

  cout << total << "\n";
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (flow[i][j] > 0) {
        cout << i << " " << j << " " << flow[i][j] << "\n";
      }
    }
  }
}