#include <bits/stdc++.h>
using namespace std;

int main() {
  int n, m;
  cin >> n >> m;
  vector<vector<int> > cap(n, vector<int>(n));
  for (int i = 0; i < m; i++) {
    int u, v, c;
    cin >> u >> v >> c;
    cap[u][v] = c;
  }
  vector<vector<int> > flow(n, vector<int>(n));
  int s = 0;
  int t = n - 1;

  vector<int> height(n);
  height[s] = n;
  vector<int> excess(n);
  queue<int> q;
  for (int i = 0; i < n; i++) {
    if (i != s && cap[s][i] > 0) {
      excess[i] += cap[s][i];
      flow[s][i] += cap[s][i];
      flow[i][s] -= cap[s][i];
      q.push(i);
    }
  }
  
  while (!q.empty()) {
    int cur = q.front();
    q.pop();
    for(;;) {
      assert(excess[cur] > 0);
      for (int i = 0; i < n; i++) {
        if (height[cur] > height[i] && cap[cur][i] - flow[cur][i] > 0) {
          bool enqueue = (excess[i] == 0);
          int extra = min(excess[cur], cap[cur][i] - flow[cur][i]);
          assert(extra > 0);
          excess[i] += extra;
          excess[cur] -= extra;
          flow[cur][i] += extra;
          flow[i][cur] -= extra;
          if (enqueue && i != s && i != t) {
            q.push(i);
          }
          if (excess[cur] == 0)
             break;           
        }
      }
      if (excess[cur] == 0)
        break;           
      height[cur]++;
    }
  }

  cout << excess[t] << "\n";  
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (flow[i][j] > 0) {
        cout << i << " " << j << " " << flow[i][j] << "\n";
      }
    }
  }

}